#include "stdafx.h"
#include <opencv2\opencv.hpp>

using namespace cv;
using namespace std;

Mat Erosion(Mat mask, int nSESize)
{
	int w = mask.cols;
	int h = mask.rows;
	int val = 255;
	Mat morph(mask.size(), CV_8U, Scalar(0));
	mask.copyTo(morph);
	int nHalfSESize = nSESize >> 1;
	int nFullSESize = nSESize * nSESize;
	int nFullSEValue = val * nFullSESize;

	for (int y = nHalfSESize; y < h - nHalfSESize; y++)
	{
		for (int x = nHalfSESize; x < w - nHalfSESize; x++)
		{
			int sum = 0;
			for (int m = -nHalfSESize; m <= nHalfSESize; m++)
			{
				for (int l = -nHalfSESize; l <= nHalfSESize; l++)
				{
					int idxx = x + l;
					int idxy = y + m;
					if ((idxx < 0) || (idxx > w - 1) || (idxy < 0) || (idxy > h - 1)) continue;
					sum += mask.at<uchar>(idxy, idxx);
				}
			}
			//
			if (sum != nFullSEValue)
			{
				for (int m = -nHalfSESize; m <= nHalfSESize; m++)
				{
					for (int l = -nHalfSESize; l <= nHalfSESize; l++)
					{
						int idxx = x + l;
						int idxy = y + m;
						if ((idxx < 0) || (idxx > w - 1) || (idxy < 0) || (idxy > h - 1)) continue;
						morph.at<uchar>(idxy, idxx) = 0;
					}
				}
			}
		}
	}
	return morph;
}

